#include "stdafx.h"
#include "Mecab_Wrap.h"
#include "mecab.h"
#include <string>

using std::string;

#pragma comment(lib,"libmecab.lib")

namespace MeCab_Wrap{
	MeCab::Tagger *tagger=NULL;

	bool Init()
	{
		tagger = MeCab::createTagger("--rcfile=.\\Mecab_Module\\mecabrc");

		if(tagger==NULL) return false;

		return true;
	}

	int Trans(LPSTR szDest, int nDestSize, LPCSTR szSrc)
	{
		const MeCab::Node* node;

		string strDest;

		node = tagger->parseToNode(szSrc);

		for (; node; node = node->next) {
			if (node->stat != MECAB_BOS_NODE&&node->stat != MECAB_EOS_NODE)
			{
				string strTmp=node->feature;
				string::size_type nIdx=strTmp.rfind(',');
				if(nIdx!=strTmp.npos)
				{
					strTmp=strTmp.substr(nIdx+1);
					if(strTmp=="*")
					{
						strDest.append(node->surface,node->surface+node->length);
					}
					else
					{
						strDest.append(strTmp.begin(),strTmp.end());
					}

					if(node->next->stat!=MECAB_EOS_NODE)
					{
						strDest.push_back(' ');
					}
				}
			}
		}

		strncpy(szDest,strDest.c_str(),nDestSize);
		return strDest.size();
	}

	bool End()
	{
		delete tagger;
		return true;
	}
};